PFont font;
int num ;
int button_size=20;  
color fill_color;  
int penSize;  
color eraser_color=color(255);  
color active_color;  

int drawMode;  
int x, y, x1, y1;  

int points=0;  
 
PImage img;  
String path;  
String saveScreen;  
PImage canvas = createImage(width,height,RGB);  

void setup(){  
  size(600,600);  
  background(255);  
}  
void draw()  {  
  drawTools();  
  clear();  
  drawingMode();  

}  

void drawTools()  {  
  stroke(0);
  fill(255,0,0);  //빨
  rect(0,0,button_size, button_size);  
  stroke(0);
  fill(255,100,0); //주  
  rect(button_size,0,button_size,button_size);  
  stroke(0);
  fill(255,255,0);  //노
  rect(button_size*2,0,button_size,button_size);  
  stroke(0);
  fill(0,255,0); //초  
  rect(0,button_size,button_size,button_size);  
  stroke(0);
  fill(0,0,255); //파 
  rect(button_size,button_size,button_size,button_size);  
  stroke(0);
  fill(200,0,100); //보
  rect(button_size*2,button_size,button_size,button_size);  
  stroke(0);
  fill(0); //검
  rect(0,button_size*2,button_size,button_size);  
  stroke(0); 
  fill(255); //흰
  rect(button_size,button_size*2,button_size,button_size);  
  stroke(0);  
  fill(255,170,230); //핑
  rect(button_size*2,button_size*2,button_size,button_size);  


  //brush 
  stroke(0,0,0); 
  fill(255,255,255);  
  rect(0,button_size*4,button_size*2,button_size*2);    
  noStroke();  
  fill(0);  
  ellipse(18,button_size*4+20,3,3);  

  stroke(0,0,0);
  fill(255,255,255);  
  rect(0,button_size*6,button_size*2,button_size*2);  
  noStroke();  
  fill(0);  
  ellipse(18,button_size*6+20,5,5);  

  stroke(0,0,0); 
  fill(255,255,255);  
  rect(0,button_size*8,button_size*2,button_size*2);  
  noStroke();  
  fill(0);  
  ellipse(18,button_size*8+20,10,10);  

  //clear  
  stroke(0);  
  fill(0);  
  rect(420,540,60,60);  
  font= loadFont("ArialMT-20.vlw");
  textFont(font);
  text("Clear!", 420,540);

  //img Lode
  noStroke();  
  fill(255,124,159);  
  rect(480,540,60,60);
  font= loadFont("ArialMT-20.vlw");
  textFont(font);
  text("Open", 485,540);  

  //save image  
  noStroke();  
  fill(124,179,255);  
  rect(540,540,60,60);  
  font= loadFont("ArialMT-20.vlw");
  textFont(font);
  text("Save", 550,540);  

  fill(200);
  font= loadFont("ArialMT-20.vlw");
  textFont(font);
  text("20071592 Park min sun", 10,590);  
  fill(150);
  text("Processing_drawing Tool", 10,570);  
}

void mousePressed() {     
  //lode
  if(mouseButton==LEFT){  
if(mouseX>480 && mouseX<540 && mouseY>540 && mouseY<600){  
  //if(mouseX>0 && mouseX<600 && mouseY>0 && mouseY<600){  
  path=selectInput();  
      if(path!=null)  
        img=loadImage(path);  
      image(img,60,0);
    }  

    //save
    if(mouseX>540&&mouseX<600&&mouseY>540&&mouseY<600){
      canvas = get(60,0,width-60,height-60);  
      saveScreen = selectOutput();  
      if(saveScreen != null);  
      canvas.save(saveScreen);  
    }  

    //팔레트
    if((mouseX > 0 && mouseX < 60)&&(mouseY > 0 && mouseY < 60)){  
      int colornumber=(int)(mouseX/button_size)+(int)((mouseY/button_size*3));  
      println(colornumber);  
      switch(colornumber)  
      {  

      case 0:  
        fill_color=color(255,0,0); //빨 
        break;  
      case 1:  
        fill_color=color(255,100,0);//주

        break;  
      case 2:  
        fill_color=color(255,255,0);//노
        break;  

      case 3:  
        fill_color=color(0,255,0);//초

        break;  
      case 4:  
        fill_color=color(0,0,255);//파
        break;  

      case 5:  
        fill_color=color(200,0,100);//보 

        break;          

      case 6:  
        fill_color=color(0);//검

        break;          

      case 7:  
        fill_color=color(255);//흰

        break;          

      case 8:  
        fill_color=color(255,170,230);//핑

        break;          
      }  
      active_color=fill_color;  
    }  
  }  

  if(mouseY > 50 && mouseY < 200){  
    if(mouseX > 0 && mouseX < 30){  
      active_color=fill_color;
    } 

    if(mouseX > 30 && mouseX < 60){  
      active_color=color(255); 
    }  

    if(mouseX > 0 && mouseX < 30){  
      int brushnumber=(int)((mouseY-140)/40);  
      println("click"+num++);  


      switch(brushnumber){    
      case 0:  
        penSize=3;  
        break;  
      case 1:  
        penSize=5;  
        break;                  
      case 2:  
        penSize=10  ;
        break;          
      }
    }  
  }  
}  


void drawingMode(){  

  if(mousePressed){  
          if((mouseX>0&&mouseX<600)&&(mouseY>0&&mouseY<600)){  
      drawMode=1;
    }
  }
}  

void clear(){  

  if(mousePressed){  
    if((mouseX>420&&mouseX<460)&&(mouseY>540&&mouseY<600)){  
      background(255);  
      drawTools(); 
    }
  }
}  


void mouseDragged(){  
  if(drawMode==1){  
    noStroke();  
    fill(active_color);  
    ellipse(mouseX,mouseY,penSize,penSize);
  }
}  

